// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'controllers', 'services', 'factories','pascalprecht.translate', 'translations'])

.run(function($ionicPlatform, RequestsService, $state, $timeout , $ionicHistory, $ionicPopup, $translate) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)

    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
      StatusBar.backgroundColorByHexString("#0e3b62");

    }

    if(typeof navigator.globalization !== "undefined") {
      navigator.globalization.getPreferredLanguage(function(language) {
        $translate.use((language.value).split("-")[0]).then(function(data) {
          console.log("SUCCESS -> " + data);
        }, function(error) {
          console.log("ERROR -> " + error);
        });
      }, null);
    }

    //======ADMOB code start=============
    if (window.AdMob) {

      // Detect platform
      var adbannerid = "";
      var adinterstitialid = "";
      if (/(android)/i.test(navigator.userAgent)) { // for android
        adbannerid = "ca-app-pub-9274167216302943/8491500912";
        adinterstitialid = "ca-app-pub-9274167216302943/9968234114";
      } else if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
        adbannerid = "ca-app-pub-9274167216302943/6875166911";
        adinterstitialid = "ca-app-pub-9274167216302943/8351900113";
      }

      // Create banner
      window.AdMob.createBanner({
        adId: adbannerid,
        position: AdMob.AD_POSITION.BOTTOM_CENTER,
        isTesting: false,
        autoShow: false
      });
      window.AdMob.prepareInterstitial({
        adId: adinterstitialid,
        isTesting: false,
        autoShow: false
      });
    } else {
      console.log('AdMob Unavailable');
    }
    //======ADMOB code end=============

    //=======PUSH NOTIFICATIONS Code Start=======
//NEW
    //alert("got here")
    var push = PushNotification.init({
      android: {
        senderID: "307766415106"
      },
      browser: {
        pushServiceURL: 'http://push.api.phonegap.com/v1/push'
      },
      ios: {
        alert: "true",
        badge: "true",
        sound: "true"
      }//,
      //windows: {}
    });


    push.on('registration', function(data) {

      stored_device_token = window.localStorage.getItem('stored_device_token')
      device_token = data.registrationId;
      try_register_again = false;
      if (stored_device_token === null){
        console.log("no device token is stored, new or app update");
        try_register_again = true;

      }
      else if (device_token===stored_device_token){
       /* try_register_again = false;
        console.log("device token is the same");*/
        // here we should check for differences between localstorage and remote config

         try_register_again = true;
          // device token is the same but for now always update the register because of the email.
         }
      else{
        console.log("device tokens different, app updated");
        try_register_again = true;
        //happens when device token expires or app updates need to send register again according to local storage
      }
      if (try_register_again){
        /*if (window.localStorage.getItem('starter_facebook_user')===null || ( window.localStorage.getItem('follow_games')===null && window.localStorage.getItem('follow_teams')===null) ){
          console.log("empty follow data");
          //if empty no data is lost just ignore
        }
        else{*/
          // console.log("follow data exists: trying to register new token");
          //APP NAME FOR STORAGE
          app_name = "soccerjoke";
          user = JSON.parse( window.localStorage.getItem('starter_facebook_user') || 'null' ) || '';
          userEmail = user.email || '';
          //console.log("user: "+user.toString());
          //console.log("userEmail: "+userEmail.toString());

          RequestsService.register(device_token, app_name, userEmail);


        // }

      }
      window.localStorage.setItem('stored_device_token', device_token);
      //alert(device_token)
      console.log('your registration id is: ' + data.registrationId);
    });
    push.on('notification', function(data) {

console.log(data);
      if (data.additionalData.title){ //ios
        title= data.additionalData.title;
      }
      else{ //android
        title= data.title;
      }
      $ionicPopup.alert({
        okText: 'Ok',
        title: title, //was data.alert
        template: data.message
      }).then(function (result) {
      });
  /*    console.log("should not open ionicpopup");
      console.log(data.message);
      console.log(title);
      console.log(data.count);
      console.log(data.sound);
      console.log(data.image);
      console.log(data.additionalData);*/
    });
    push.on('error', function(e) {
      console.log(e.message);
    });

    //======= NEW PUSH NOTIFICATIONS Code End =======

    //======GOOGLE ANALYTICS code start=============
    if (typeof analytics !== undefined) {
      analytics.startTrackerWithId("UA-81634311-2");

      analytics.trackView("Iniciou APP");
    } else {
      console.log("Google Analytics Unavailable");
    }
    //======GOOGLE ANALYTICS code end=============
    //======Back Button events=============
    var backbutton=0;
    $ionicPlatform.registerBackButtonAction(function (event) {

      if (($state.$current.name == "app.main")||($state.$current.name == "app.goals") || ($state.$current.name == "app.pictures") ||
        ($state.$current.name == "app.videos") ||
        ($state.$current.name == "app.favourites"))
         {
        if(backbutton==0){
          backbutton++;
          window.plugins.toast.showLongBottom('Press again to exit');
          $timeout(function(){backbutton=0;},3000);
        }else{
          navigator.app.exitApp();
        }
        console.log("one");
      }/*else if() {
        console.log("two");
        $ionicHistory.nextViewOptions({
          disableBack: true
        });
        $state.go("app.main");
      }*/else{
        console.log("three");
        $ionicHistory.goBack();
      }
    }, 100);

  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

    .state('pre', {
      url: '/pre',
      templateUrl: "templates/pre.html",
      controller: 'PreCtrl'
    })

    .state('login', {
      url: '/login',
      templateUrl: "templates/login.html",
      controller: 'LoginCtrl'
    })

    .state('load', {
      url: '/load',
      templateUrl: "templates/load.html",
      controller: 'LoadCtrl'
    })

  .state('app.main', {
    url: '/main',
    views: {
      'menuContent': {
        templateUrl: 'templates/main.html'
      }
    }
  })
    .state('app.pictures', {
    url: '/pictures',
    views: {
      'menuContent': {
        controller:'PicturesCtrl',
        templateUrl: 'templates/pictures.html'
      }
    }
  })
    .state('app.videos', {
    url: '/videos',
    views: {
      'menuContent': {
        controller:'VideosCtrl',
        templateUrl: 'templates/videos.html'
      }
    }
  })
    .state('app.goals', {
    url: '/goals',
    views: {
      'menuContent': {
        controller:'GoalsCtrl',
        templateUrl: 'templates/goals.html'
      }
    }
  })
    .state('app.favourites', {
    url: '/favourites',
    views: {
      'menuContent': {
        controller:'FavouritesCtrl',
        templateUrl: 'templates/favourites.html'
      }
    }
  })
    .state('app.test', {
    url: '/test',
    views: {
      'menuContent': {
        controller:'TestCtrl',
        templateUrl: 'templates/test.html'
      }
    }
  })
  .state('app.details', {
    url: '/main/:cat/:imageId',
    views: {
      'menuContent': {
        controller:'DetailsCtrl',
        templateUrl: 'templates/imagedetails.html'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('pre');
});
