angular.module('controllers', [])


  .controller('PreCtrl', function ($scope, $state, $q, $ionicLoading, UserService, $ionicViewSwitcher, $timeout, $window, $ionicHistory, $translate) {
    document.addEventListener("deviceready", onDeviceReady, false);
    function onDeviceReady() {
      screen.lockOrientation('portrait'); // or 'portrait'
    }

    //*******----  FACEBOOK LOGIN  ---*********//

    //This is the success callback from the login method
    var fbLoginSuccess = function (response) {
      if (!response.authResponse) {
        fbLoginError("Cannot find the authResponse");
        return;
      }

      var authResponse = response.authResponse;
      //FIRST TIME LOGIN
      getFacebookProfileInfo(authResponse)
        .then(function (profileInfo) {
          //for the purpose of this example I will store user data on local storage
          UserService.setUser({
            authResponse: authResponse,
            userID: profileInfo.id,
            name: profileInfo.name,
            email: profileInfo.email,
            picture: "https://graph.facebook.com/" + authResponse.userID + "/picture?width=320&height=320"
          });

          $ionicLoading.hide();
          console.log('Fb login success, user access token is: ' + authResponse.accessToken);
          $window.localStorage.setItem('authenticationPreference', 'facebook');
          $ionicViewSwitcher.nextDirection('enter');
          $state.go('load');

        }, function (fail) {
          //fail get profile info
          console.log('profile info fail', fail);
        });
    };


    //This is the fail callback from the login method
    var fbLoginError = function (error) {
      console.log('fbLoginError' + error.errorMessage);
      window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
      $ionicLoading.hide();
    };

    //this method is to get the user profile info from the facebook api
    var getFacebookProfileInfo = function (authResponse) {
      var info = $q.defer();

      facebookConnectPlugin.api('/me?fields=email,name&access_token=' + authResponse.accessToken, ['email', 'public_profile', 'user_friends'],
        function (response) {
          console.log(response);
          info.resolve(response);
        },
        function (response) {
          console.log(response);
          info.reject(response);
        }
      );
      return info.promise;
    };

    //This method is executed when the user press the "Login with facebook" button
    facebookSignIn = function () {

      facebookConnectPlugin.getLoginStatus(function (success) {
        if (success.status === 'connected') {
          // the user is logged in and has authenticated your app, and response.authResponse supplies
          // the user's ID, a valid access token, a signed request, and the time the access token
          // and signed request each expire
          console.log('getLoginStatus', success.status);

          //check if we have our user saved
          var user = UserService.getUser('facebook');
          if (!user.userID) {
            getFacebookProfileInfo(success.authResponse)
              .then(function (profileInfo) {

                //for the purpose of this example I will store user data on local storage
                UserService.setUser({
                  authResponse: success.authResponse,
                  userID: profileInfo.id,
                  name: profileInfo.name,
                  email: profileInfo.email,
                  picture: "https://graph.facebook.com/" + success.authResponse.userID + "/picture?width=320&height=320"
                });
                $window.localStorage.setItem('authenticationPreference', 'facebook');
                $ionicViewSwitcher.nextDirection('enter');
                $state.go('load');


              }, function (fail) {
                //fail get profile info
                console.log('profile info fail', fail);
              });
          } else {
            $window.localStorage.setItem('authenticationPreference', 'facebook');
            $ionicViewSwitcher.nextDirection('enter');
            $state.go('load');
            console.log('here');
          }

        } else {
          //if (success.status === 'not_authorized') the user is logged in to Facebook, but has not authenticated your app
          //else The person is not logged into Facebook, so we're not sure if they are logged into this app or not.
          console.log('getLoginStatus', success.status);

          $ionicLoading.show({
            template:  $translate.instant('login_authenticating')
          });

          //ask the permissions you need. You can learn more about FB permissions here: https://developers.facebook.com/docs/facebook-login/permissions/v2.4
          facebookConnectPlugin.login(['email', 'public_profile', 'user_friends'], fbLoginSuccess, fbLoginError);
        }
      });
    };

    $scope.authPreference = function () {
      if ($window.localStorage.getItem('authenticationPreference') != null) {
        console.log('auth preference is ' + $window.localStorage.getItem('authenticationPreference'));
        if ($window.localStorage.getItem('authenticationPreference') == 'facebook') {
          facebookSignIn();
        } else if ($window.localStorage.getItem('authenticationPreference') == 'local') {
          $ionicViewSwitcher.nextDirection('enter');
          $state.go('login')
        }
      } else {
        console.log('auth preference is null or undefined, first time running?');
        $ionicViewSwitcher.nextDirection('enter');
        $state.go('login')
      }
    };

    $timeout(function () {
      $scope.authPreference()
    }, 1500);

    $scope.$on("$ionicView.unloaded", function (event, data) {
      $ionicHistory.clearHistory();
    });
  })

  .controller('LoginCtrl', function ($scope, $state, $ionicViewSwitcher, $translate) {
    $scope.doLocalLogin = function () {
      var networkState = navigator.connection.type;
      if(networkState=='none'){
        /*$translate('generic_connection_error')
          .then(function (translatedValue) {
            window.plugins.toast.showLongBottom(translatedValue);
          });*/
        window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
      }else{
        $ionicViewSwitcher.nextDirection('enter');
        $state.go('load')
      }
    };

    $scope.doFBLogin = function () {
      facebookSignIn();
    }

  })

  .controller('LoadCtrl', function ($scope, $state, $interval, $ionicHistory) {
    $scope.progressval = 0;
    $scope.stopinterval = null;


    $scope.updateProgressbar = function () {
      startprogress();
    };

    function startprogress() {
      $scope.progressval = 0;

      if ($scope.stopinterval) {
        $interval.cancel($scope.stopinterval);
      }

      $scope.stopinterval = $interval(function () {
        $scope.progressval = $scope.progressval + 2;
        if ($scope.progressval >= 100) {
          $interval.cancel($scope.stopinterval);
          $state.go('app.main');
          return;
        }
      }, 100);
    }

    startprogress();
    $scope.$on("$ionicView.unloaded", function (event, data) {
      $ionicHistory.clearHistory();
    });

  })

  .controller('AppCtrl', function ($scope, DataService, $ionicHistory, UserService, $ionicLoading, $state,$ionicActionSheet, $translate) {

    // With the new view caching in Ionic, Controllers are only called
    // when they are recreated or on app start, instead of every page change.
    // To listen for when this page is active (for example, to refresh data),
    // listen for the $ionicView.enter event:
    //$scope.$on('$ionicView.enter', function(e) {
    //});

    $scope.showLogOutMenu = function() {
      var hideSheet = $ionicActionSheet.show({
        destructiveText: $translate.instant('menu_signout'),
        titleText: $translate.instant('menu_signout_text'),
        cancelText: $translate.instant('menu_signout_canceltext'),
        cancel: function() {},
        buttonClicked: function(index) {
          return true;
        },
        destructiveButtonClicked: function(){
          $ionicLoading.show({
            template: $translate.instant('menu_signout_loggingout')
          });

          // Facebook logout
          facebookConnectPlugin.logout(function(){
              $ionicLoading.hide();
              $ionicHistory.clearHistory();
              window.localStorage.setItem('authenticationPreference', 'local');
              $ionicHistory.clearCache().then(function(){ $state.go('pre') })
            },
            function(fail){
              $ionicLoading.hide();
            });
        }
      });
    };

    $scope.redirectToLogin = function () {
      $ionicHistory.clearHistory();
      window.localStorage.setItem('authenticationPreference', 'local');
      $ionicHistory.clearCache().then(function(){ $state.go('pre') })
    }

    $scope.myGoBack = function () {
      $ionicHistory.goBack();
    };

    $scope.isFbLogin = function () {
      return window.localStorage.getItem('authenticationPreference') == 'facebook';
    };
    // LOAD USER FB INFO
    $scope.user = UserService.getUser();

    //Show Banner
    try {
      if (AdMob) {
        AdMob.showInterstitial();
        AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER);
      }
    } catch (e) {
      console.log('AdMob not available');
    }

    $scope.masonryScript = function () {
      $(document).ready(function () {
        console.log("EXECUTING MASONRY SCRIPT!");
        var left_column_height = 0;
        var right_column_height = 0;
        var items = $('.imgitem');
        var img = $('.animg img');
        for (var i = 0; i < items.length; i++) {

          // Add specific class if the image is vertical or horizontal
          if (img.eq(i).width() < img.eq(i).height()) {
            if (img.eq(i).hasClass('horiz') || img.eq(i).hasClass('vert')) {
              // do nothing
            } else {
              img.eq(i).addClass('vert');
            }
          } else {
            if (img.eq(i).hasClass('horiz') || img.eq(i).hasClass('vert')) {
              // do nothing
            } else {
              img.eq(i).addClass('horiz');
            }
          }

          // Re-order the grid
          if (left_column_height > right_column_height) {
            right_column_height += items.eq(i).addClass('right').outerHeight(true);
          } else {
            if (items.eq(i).hasClass('right')) {
              items.eq(i).removeClass('right');
            }
            left_column_height += items.eq(i).outerHeight(true);
          }
        }
      });
    };

    $scope.imgData = null;

    $scope.numberOfItemsToDisplay = 10; // Use it with limit to in ng-repeat

    $scope.addMoreItem = function () {
      if ($scope.imgData.length > $scope.numberOfItemsToDisplay) {
        $scope.numberOfItemsToDisplay += 10; // load number of more items
      }
      $scope.masonryScript();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    };

    $scope.fbInvite = function (){
      $ionicLoading.show({
        template: '<ion-spinner></ion-spinner>' +
        '<p>'+$translate.instant('generic_loading')+'</p>',
        showBackdrop: true
      });
      facebookConnectPlugin.appInvite(
        {
          url: "https://fb.me/1807876306157160",
          picture: "http://c.toptoolapps.com/data/soccerjoke.com/logofundo.png"
        },
        function(obj){
          if(obj) {
            if(obj.completionGesture == "cancel") {
              // user canceled, bad guy
              console.log("user canceled");
            } else {
              console.log("user invited");
              // user really invited someone :)
            }
          } else {
            console.log("user pressed done");
            // user just pressed done, bad guy
          }
          $ionicLoading.hide();

        },
        function(obj){
          // error
          console.log(obj);
          $ionicLoading.hide();

        }
      );

    };

    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>' +
      '<p>'+$translate.instant('generic_loading')+'</p>',
      showBackdrop: true
    });

    $scope.$on("$ionicView.afterEnter", function (event, data) {
      DataService.getAllImgs()
        .then(function (response) {
          if($scope.imgData != null){
            if (response == $scope.imgData) {
              /*            $ionicLoading.hide();
              window.plugins.toast.showLongBottom($translate.instant('generic_connection_error')) */
              console.log('same data, do nothing');
            }
          }
          else {
            $scope.imgData = response;
            console.log('SERVICE DONE');
            $scope.masonryScript();
            $ionicLoading.hide();
          }
        }, function (error) {
          $scope.masonryScript();
          $ionicLoading.hide();
          window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
        });
    });

  })

  .controller('PicturesCtrl', function ($scope, DataService, $ionicLoading, $translate) {
    $scope.$on("$ionicView.afterEnter", function (event, data) {
      $scope.noDataMessage = false;
      DataService.getImgs('pictures')
        .then(function (response) {
          if($scope.imgData != null){
            if (response == $scope.imgData) {
              /*            $ionicLoading.hide();
                     window.plugins.toast.showLongBottom($translate.instant('generic_connection_error')) */
              console.log('same data, do nothing');
            }
            $scope.masonryScript();
            $scope.noDataMessage = false;
          } else if (response == 0) {
            $scope.noDataMessage = false;
            $scope.masonryScript();
            $ionicLoading.hide();
            window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
          } else if (response == 1){
            $scope.noDataMessage = true;
            $scope.imgData = null;
            $ionicLoading.hide();
          } else {
            $scope.noDataMessage = false;
            $scope.imgData = response;
            console.log('PICTURES SERVICE DONE');
            $scope.masonryScript();
            $ionicLoading.hide();
          }
        });
    });
    $scope.imgData = null;
    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>' +
      '<p>'+$translate.instant('generic_loading')+'</p>',
      showBackdrop: true
    });

    $scope.numberOfItemsToDisplay = 10; // Use it with limit to in ng-repeat
    $scope.addMoreItem = function () {
      if ($scope.imgData.length > $scope.numberOfItemsToDisplay) {
        $scope.numberOfItemsToDisplay += 10; // load number of more items
      }
      $scope.masonryScript();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }
  })

  .controller('VideosCtrl', function ($scope, DataService, $ionicLoading, $translate) {
    $scope.$on("$ionicView.afterEnter", function (event, data) {
      $scope.noDataMessage = false;
      DataService.getImgs('videos')
        .then(function (response) {
          if($scope.imgData != null){
            if (response == $scope.imgData) {
              /*            $ionicLoading.hide();
                     window.plugins.toast.showLongBottom($translate.instant('generic_connection_error')) */
              console.log('same data, do nothing');
            }
            $scope.masonryScript();
            $scope.noDataMessage = false;
          } else if (response == 0) {
            $scope.noDataMessage = false;
            $scope.masonryScript();
            $ionicLoading.hide();
            window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
          }else if (response == 1){
            $scope.noDataMessage = true;
            $scope.imgData = null;
            $ionicLoading.hide();
          } else {
            $scope.noDataMessage = false;
            $scope.imgData = response;
            console.log('VIDEOS SERVICE DONE');
            $scope.masonryScript();
            $ionicLoading.hide();
          }
        });
    });
    $scope.imgData = null;
    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>' +
      '<p>'+$translate.instant('generic_loading')+'</p>',
      showBackdrop: true
    });


    $scope.numberOfItemsToDisplay = 10; // Use it with limit to in ng-repeat
    $scope.addMoreItem = function () {
      if ($scope.imgData.length > $scope.numberOfItemsToDisplay) {
        $scope.numberOfItemsToDisplay += 10; // load number of more items
      }
      $scope.masonryScript();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }
  })

  .controller('GoalsCtrl', function ($scope, DataService, $ionicLoading, $translate) {
    $scope.$on("$ionicView.afterEnter", function (event, data) {
      $scope.noDataMessage = false;
      DataService.getImgs('goals')
        .then(function (response) {
          if($scope.imgData != null){
            if (response == $scope.imgData) {
              /*            $ionicLoading.hide();
                     window.plugins.toast.showLongBottom($translate.instant('generic_connection_error')) */
              console.log('same data, do nothing');
            }
            $scope.masonryScript();
            $scope.noDataMessage = false;
          } else if (response == 0) {
            $scope.noDataMessage = false;
            $scope.masonryScript();
            $ionicLoading.hide();
            window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
          } else if (response == 1){
            $scope.noDataMessage = true;
            $scope.imgData = null;
            $ionicLoading.hide();
          } else {
            $scope.noDataMessage = false;
            $scope.imgData = response;
            console.log('GOALS SERVICE DONE');
            $scope.masonryScript();
            $ionicLoading.hide();
          }
        });
    });
    $scope.imgData = null;
    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>' +
      '<p>'+$translate.instant('generic_loading')+'</p>',
      showBackdrop: true
    });


    $scope.numberOfItemsToDisplay = 10; // Use it with limit to in ng-repeat
    $scope.addMoreItem = function () {
      if ($scope.imgData.length > $scope.numberOfItemsToDisplay) {
        $scope.numberOfItemsToDisplay += 10; // load number of more items
      }
      $scope.masonryScript();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }
  })

  .controller('FavouritesCtrl', function ($scope, DataService, $ionicLoading, $translate) {
    $scope.$on("$ionicView.afterEnter", function (event, data) {
      $scope.noFavouritesMessage = false;
      DataService.getImgs('favourites')
        .then(function (response) {
          if (response == 0) {
            $scope.masonryScript();
            $scope.noFavouritesMessage = false;
            $scope.imgData = null;
            $ionicLoading.hide();
            window.plugins.toast.showLongBottom($translate.instant('generic_connection_error'))
          }
          else if (response == 1){
            $scope.imgData = null;
            $scope.noFavouritesMessage = true;
            $ionicLoading.hide();
          }else {
            $scope.noFavouritesMessage = false;
            $scope.imgData = response;
            console.log('FAVOURITES SERVICE DONE');
            $scope.masonryScript();
            $ionicLoading.hide();
          }
        });
    });
    $scope.imgData = null;
    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>' +
      '<p>'+$translate.instant('generic_loading')+'</p>',
      showBackdrop: true
    });

    $scope.numberOfItemsToDisplay = 10; // Use it with limit to in ng-repeat
    $scope.addMoreItem = function () {
      if ($scope.imgData.length > $scope.numberOfItemsToDisplay) {
        $scope.numberOfItemsToDisplay += 10; // load number of more items
      }
      $scope.masonryScript();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }
  })

  .controller('DetailsCtrl', function ($scope, $stateParams, ImgFactory, $state, $ionicHistory, $ionicViewSwitcher, CommentService, DataService, $translate) {
    $scope.$on('$ionicView.enter', function (e) {
      $ionicHistory.removeBackView();
    });

    $scope.selectedImage = ImgFactory.getSelectedImage($scope.imgData, $stateParams.imageId);
    CommentService.getComments($stateParams.imageId)
      .then(function (response) {
        if (response == 0) {
          $scope.selectedImageComments = null;
        }
        else {
          $scope.selectedImageComments = response;
          console.log('COMMENTS SERVICE DONE');
        }
      });

    $scope.postData = {};
    $scope.newComment = function (imageId) {
      var networkState = navigator.connection.type;
      if(networkState=='none'){
        window.plugins.toast.showLongBottom($translate.instant('details_comment_connection_error'));
      }else{
      CommentService.saveComment($scope.postData, imageId, $scope.user)
        .then(function (response) {
          if (response == 0) {
          }
          else {
            $scope.postData = {};
            CommentService.getComments($stateParams.imageId)
              .then(function (response) {
                if (response == 0) {
                  $scope.selectedImageComments = null;
                }
                else {
                  $scope.selectedImageComments = response;
                  console.log('COMMENTS SERVICE DONE');
                }
              });
            console.log('COMMENT SAVED');
          }
      });
      }
    };

    $scope.isFavourite = function () {
      return DataService.isFavourite($scope.selectedImage);
    };

    $scope.updateFavourites = function (imageData) {
      DataService.updateFavourites(imageData);
    };

    $scope.shareToFB = function (id) {
      facebookConnectPlugin.showDialog({
          method: "share",
          href: "http://soccerjoke.com/feed/" + id
        },
        function onShareSuccess(result) {
          console.log("Posted. ", result)
        },
        function (result) {
          console.log("Failure", result)
        })
    };

    $scope.showNext = function () {
      $scope.selectedImageId = null;
      $scope.selectedImageId = ImgFactory.getNextImage($scope.imgData, $stateParams.imageId, $stateParams.cat);
      if ($scope.selectedImageId) {
        $state.go('app.details', {imageId: $scope.selectedImageId});
      }
    };

    $scope.showPrevious = function () {
      $scope.selectedImageId = null;
      $scope.selectedImageId = ImgFactory.getPreviousImage($scope.imgData, $stateParams.imageId, $stateParams.cat);
      if ($scope.selectedImageId) {
        $ionicViewSwitcher.nextDirection('back');
        $state.go('app.details', {imageId: $scope.selectedImageId});
      }
    }

    $scope.numberOfComments = 5; // Use it with limit to in ng-repeat
    $scope.addMoreComments = function () {
      if ($scope.selectedImageComments.length > $scope.numberOfComments) {
        $scope.numberOfComments += 5; // load number of more items
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }
  })




  // EXperimental Controller
  .controller('TestCtrl', function ($scope, DataService, $ionicLoading,$translate) {
    $scope.imgData = null;
    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>' +
      '<p>'+$translate.instant('generic_loading')+'</p>',
      showBackdrop: true
    });
    DataService.getImgs('pictures')
      .then(function (response) {
        if (response == 0) {
          $scope.imgData = null;
        }
        else {
          $scope.imgData = response;
          console.log('PICTURES SERVICE DONE');
          $scope.masonryScript();
          $ionicLoading.hide();
        }
      });

    $scope.numberOfItemsToDisplay = 10; // Use it with limit to in ng-repeat
    $scope.addMoreItem = function () {
      if ($scope.imgData.length > $scope.numberOfItemsToDisplay) {
        $scope.numberOfItemsToDisplay += 10; // load number of more items
      }
      $scope.masonryScript();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    }


  })
