angular.module('factories', [])


  .factory('ImgFactory', function () {
    var selectedItem = null;
    return {
      getSelectedImage: function (images, id) {
        if (!id) return null;

        for (var pl in images) {
          if (images[pl].id == id) {
            selectedItem = images[pl];
            return selectedItem;
          }
        }
        return null;
      },
      getNextImage: function (images, id, filter) {
        if (!id) return null;
        // loop through the array
        for (var pl = 0 in images) {
          //find the current image id
          if (images[pl].id == id) {
            var i = parseInt(pl) + 1;
            // loop the array for the next image
            for (i; i < images.length; i++) {
              if (filter == 'all') {
                return images[i].id;
              } else if (images[i].category == filter) {
                selectedItem = images[i].id;
                return selectedItem;
              }
            }
          }
        }
        return null;
      },
      getPreviousImage: function (images, id, filter) {
        if (!id) return null;
        for (var pl = 0 in images) {
          if (images[pl].id == id) {
            var i = parseInt(pl) - 1;
            for (i; i >= 0; i--) {
              if (filter == 'all') {
                return images[i].id;
              } else if (images[i].category == filter) {
                selectedItem = images[i].id;
                return selectedItem;
              }
            }
          }
        }
        return null;
      }
    }
  })


  .factory('UserFactory', function ($http) {
    return {
      registerUser: function (data) {
        if (!data) return null;
        return $http({
          method: "POST",
          url: 'http://c.toptoolapps.com/api/appuser/',
          data: {
            'name': data.name,
            'email': data.email,
            'password': data.password
          }
        })
          .then(function (response) {
          return response
        }, function (response) {
          console.log('error', response.status);
          return response;
        });
      }
    }
  })
