angular.module('services', [])

  .service('UserService', function ($http) {

//for the purpose of this example I will store user data on ionic local storage but you should save it on a database

    var setUser = function (user_data) {
      window.localStorage.starter_facebook_user = JSON.stringify(user_data);
    };

    var deleteUser = function () {
      window.localStorage.starter_facebook_user = null;
    }

    var getUser = function () {
      return JSON.parse(window.localStorage.starter_facebook_user || '{}');
    };

    return {
      getUser: getUser,
      deleteUser: deleteUser,
      setUser: setUser
    };
  })

  .service('DataService', function ($http, $q) {
    // Strip the basename of the url
    function basename(str, sep) {
      return str.substr(str.lastIndexOf(sep) + 1);
    }

    // Transform gif ; image url equals to thumbnail
    function transformData(data) {
      angular.forEach(data, function (value, key) {
        if (value.category == 'videos' || value.category == 'goals' || value.category == 'live') {
          data[key].thumbnail = "http://soccerjoke.com/assets/admin/upld/gifs/" + value.id + "_" + basename(value.image, '/') + ".jpg";
        } else if (value.category == 'pictures') {
          data[key].thumbnail = value.image;
        }
      });
      return data;
    }

    return {
      getAllImgs: function () {
        var deferred = $q.defer();
        $http({
          method: "GET",
          url: "http://c.toptoolapps.com/data/soccerjoke.com/data.json"
          // url: "templates/data"
        }).then(function (response) {
          deferred.resolve(transformData(response.data));
          // return response.data
        }, function (response) {
 /*         console.log('error', response.status);
          return 0;*/
          deferred.reject();
        });

        return deferred.promise;
      },
      getImgs: function (filter) {
        return $http({
          method: "GET",
          url: "http://c.toptoolapps.com/data/soccerjoke.com/data.json"
          // url: "templates/data"
        }).then(function (response) {

          var aux = response.data;
          var res = [];
          if (filter == 'favourites') {
            res = angular.fromJson(window.localStorage.favourites || []);
            if (res == '') return 1;
          } else {
            for (var i = 0; i < aux.length; i++) {
              if (aux[i].category == filter) {
                res.push(aux[i]);
              }
            }
          }
          // GOT NO PICTURES, VIDEOS OR GOALS; RETURN 1
          if(res=='') return 1;
          // ELSE, TRANSFORM DATA
          return transformData(res);
        }, function (response) {
          console.log('error', response.status);
          return 0;
        });
      },
      updateFavourites: function (imageData) {
        var aux = [];
        aux = angular.fromJson(window.localStorage.favourites || []);
        /*angular.forEach(aux, function(value, key) {
         if(imageData.id == value.id){
         alert('image already saved')
         return false;
         }
         });*/
        var existsIndex = -1;
        for (var i in aux) {
          if (aux[i].id == imageData.id) {
            existsIndex = i;
            break;
          }
          existsIndex = -1;
        }
        if (existsIndex >= 0) {
          aux.splice(existsIndex, 1);
        } else {
          aux.push(imageData);
        }
        window.localStorage.favourites = JSON.stringify(aux);
      },
      isFavourite: function (imageData) {
        var aux = [];
        aux = angular.fromJson(window.localStorage.favourites || []);
        for (var i in aux) {
          if (aux[i].id == imageData.id) {
            return true;
          }
        }
        return false;
      }
    }

  })

  .service('CommentService', function ($http) {
    return {
      getComments: function (id) {
        if (!id) return null;
        return $http({
          method: "GET",
          url: "http://c.toptoolapps.com/api/comment/" + id + "/"
          // url: "templates/comments"
        }).then(function (response) {
          console.log('comment data: ' + response.data)
          if (response.data.statusCode) return null;
          return response.data
        }, function (response) {
          console.log('error', response.status);
          return 0;
        });
      },
      saveComment: function (data, imageid, user) {
        if (!imageid) return null;
        var fbpicture = "https://graph.facebook.com/" + user.userID + "/picture?width=320&height=320";
        return $http({
          method: "POST",
          url: "http://c.toptoolapps.com/api/comment/",
          params: {
            'imageid': imageid,
            'fbid': user.userID,
            'fbname': user.name,
            'fbpicture': fbpicture,
            'comment': data.comment
          }
        }).then(function (response) {
          console.log('comment saved!');
          return response.data
        }, function (response) {
          console.log('error', response.status);
          return 0;
        });
      }
    }
  })
